<template>
    <div class="col-md-6 col-sm-6">
        <form>
            <div class="col-sm-12 element-container text-element">
                <div class="form-row">
                    <div class="form-group">
                        <label class="control-label" for="sale-phone">{{ $trans('app.Номер телефона') }}</label>
                        <div class="d-flex mb-3">
                            <input placeholder="380961234567" v-model="formData.phone" autofocus name="phone" id="sale-phone" autocomplete="false" type="text" class="form-control" :class='{"is-invalid": formDataErrors["phone"]}' />
                            <div class="input-group-append">
                                <qrscanner @result="qrScannerResult"></qrscanner>
                            </div>
                        </div>
                        <small id="emailHelp" class="form-text text-muted">Номер телефона вводите в формате 380961234567</small>
                        <div v-if="formDataErrors['phone']" class="invalid-feedback">{{ formDataErrors['phone'] }}</div>
                    </div>
                </div>
                <div class="form-row">
                    <div class="form-group">
                        <button @click="findByPhone()" type="button" class="btn btn-info">Искать по номеру</button>
                    </div>
                </div>
            </div>

            <div v-if="showCreateBtn">
                <div class="text-center">
                    <a :href="$route('clients.create') + '?phone=' + formData.phone.toString() + '&back=' + backUrl + '?phone=' + formData.phone.toString()" class="btn btn-warning">{{ $trans('app.Создать клиента') }}</a>
                </div>
            </div>

            <div v-if="clientFounded" class="client-data ">


             <div class="col-sm-12 element-container">
                    <div class="form-group">
                        <div class="row">
                            <div class="col-sm-2">
                                <label class="control-label" for="sale-phone">{{ $trans('app.Клиент') }}</label>
                            </div>
                            <div class="col-sm-10 row">
                                {{ clientData.first_name }} {{ clientData.last_name }}
                            </div>
                        </div>
                    </div>
                </div>
                <hr>
                <div class="col-sm-12 element-container select-element">
                    <div class="form-group">
                        <div class="row">
                            <div class="col-sm-2">
                                <label class="control-label" for="sale-subscription">{{ $trans('app.Абонемент') }}</label>
                            </div>
                            <div class="col-sm-10 row">
                                <div class="col-sm-8 col-md-8 col-xs-8">
                                    <v-select id="sale-subscription" v-model="subscription" :options="subscriptionValues" :class='{"is-invalid": formDataErrors["phone"]}'></v-select>
                                    <div v-if="formDataErrors['subscription_id']" class="invalid-feedback">{{ formDataErrors['subscription_id'] }}</div>
                                </div>
                                <template v-if="subscription && subscriptions[subscription.value]" >
                                    <dl class="col-sm-12 col-md-12 col-xs-12">
                                        <dl class="row">
                                            <dt class="col-sm-2">
                                                {{ $trans('app.Стоимость') }}
                                            </dt>
                                            <dd class="col-sm-10">
                                                <div v-if="subscriptions[subscription.value].old_price" class="old-price">
                                                    {{ subscriptions[subscription.value].old_price }}
                                                </div>
                                                {{ subscriptions[subscription.value].price }}
                                            </dd>
                                        </dl>
                                        <dl class="row">
                                            <dt class="col-sm-2">
                                                {{ $trans('app.Срок действия') }}
                                            </dt>
                                            <dd class="col-sm-10">
                                                {{ subscriptions[subscription.value].validityText }}
                                            </dd>
                                        </dl>
                                        <dl class="row">
                                            <dt class="col-sm-2">
                                                {{ $trans('app.Кол-во занятий') }}
                                            </dt>
                                            <dd class="col-sm-10">
                                                {{ subscriptions[subscription.value].quantity_of_occupation }}
                                            </dd>
                                        </dl>
                                        <dl class="row" v-if="subscriptions[subscription.value].image != ''">
                                            <dt class="col-sm-2">
                                                {{ $trans('app.Изображение') }}
                                            </dt>
                                            <dd class="col-sm-10">
                                                <img :src="subscriptions[subscription.value].image" :alt="subscriptions[subscription.value].title">
                                            </dd>
                                        </dl>
                                    </dl>
                                </template>
                            </div>
                        </div>
                    </div>
                </div>

                <template v-if="subscription && subscriptions[subscription.value]" >
                    <div class="col-sm-12 element-container">
                        <div class="form-group">
                            <div class="row">
                                <div class="col-sm-2">
                                    <label class="control-label" >{{ $trans('app.Начало действия абонемента') }}</label>
                                </div>
                                <div class="col-sm-10">
                                    <div class="form-check row">
                                        <input class="form-check-input" type="radio" name="when_active" id="begin_today" value="1" v-model="formData.start_of_activity" >
                                        <label class="form-check-label" for="begin_today">
                                            {{ $trans('app.С момента продажи') }}
                                        </label>
                                    </div>
                                    <div class="form-check row">
                                        <input class="form-check-input" type="radio" name="when_active" id="from_first_visit" value="2" v-model="formData.start_of_activity">
                                        <label class="form-check-label" for="from_first_visit">
                                            {{ $trans('app.С первого посещения') }}
                                        </label>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div v-if="formData.start_of_activity == '2'" class="col-sm-12 element-container">
                        <div class="form-group">
                            <div class="row">
                                <div class="col-sm-2">
                                    <label class="control-label" >{{ $trans('app.Годен до') }}</label>
                                </div>
                                <div class="col-sm-10">
                                    {{ cancelperiods[subscriptions[subscription.value].available_to_before_begin_of_use].nextDateFromCurrentFormatted }}
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-12 element-container">
                        <div class="form-group">
                            <div class="row">
                                <div class="col-sm-2">
                                    <label class="control-label" >{{ $trans('app.Оплата') }}</label>
                                </div>
                                <div class="col-sm-4">
                                    <select v-model="formData.payment_source" name="" id="" class="form-control">
                                        <option value="1">{{ $trans('app.Наличный') }}</option>
                                        <option value="2">{{ $trans('app.Безналичный') }}</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-12 element-container">

                        <div class="form-group row submit-btn-wrap">
                            <div class="offset-2 col-sm-10">
                                <button @click="doSale" type="button" class="btn btn-success btn-lg">{{ $trans('app.Продать') }}</button>
                            </div>
                        </div>
                    </div>

                </template>


            </div>

        </form>
    </div>
</template>

<script>
    import Datepicker from 'vuejs-datepicker';
    import {ru} from 'vuejs-datepicker/dist/locale'

    import QRScanner from "./QRScanner";

    export default {
        props: ["phone", "subscriptions", "cancelperiods"],
        components: {
            Datepicker,
            'qrscanner': QRScanner
        },
        data: () => ({
            "datepickerLangs": ru,
            "formData": {
                "client_id":"",
                "phone":"",
                "subscription_id":"",
                "available_to_before_begin_of_use": window.moment().add(1, 'M').format('Y-MM-DD'),
                "payment_source": "1",
                "start_of_activity": "1",
            },
            "formDataErrors": {
            },
            "clientFounded": false,
            "showCreateBtn": false,
            "clientData": {},
            "subscriptionValues": [],
            "subscription": {},
            "datePickerConfig": {
                "format": 'yyyy-mm-dd',
                "value": window.moment().add(1, 'M').toDate(),
                "disabledDates": {
                    "to": window.moment().toDate(),
                    "from": window.moment().add(1, 'y').toDate(),
                },
            },
            "backUrl": "",
        }),
        methods: {
            "findByPhone": function () {
                this.resetErrors();

                axios.get(routes('clients.find-by-phone') + '?phone=' + this.formData.phone).then(response => {

                    this.clientData = response.data.data;
                    this.formData.client_id = this.clientData.id;
                    this.clientFounded = true;
                    this.showCreateBtn = false;
                }).catch(error => {
                    this.clientFounded = false;
                    if (error.response.status === 422) {
                        this.showFormErrors(error.response.data.errors);
                    } else if (error.response.status === 404) {
                        this.showCreateBtn = true;
                    }
                });
            },
            "showFormErrors": function (errors) {
                for(let field in errors) {
                    this.formDataErrors[field] = errors[field].join('; ');
                }
            },
            resetErrors: function() {
                this.formDataErrors = {
                    "phone":false
                }
            },
            "setAvailable_to_before_begin_of_use": function (date) {
                this.formData.available_to_before_begin_of_use = window.moment(date).format('Y-MM-DD');
            },
            "doSale": function () {

                let formData = new FormData();
                for(let field in this.formData) {
                    formData.append(field, this.formData[field]);
                }
                let urlParams = queryString.parse(location.search);
                if (urlParams['back']) {
                    formData.append('back', urlParams['back']);
                }

                axios.post(routes('subscriptions.sale-by-staff'), formData).then(response => {
                    location.href = response.data.back;
                }).catch(error => {

                    if (error.response.status === 422) {
                        this.showFormErrors(error.response.data.errors);
                    } else if (error.response.status === 404) {
                        this.showCreateBtn = true;
                    }
                });
            },
            qrScannerResult(result) {
                if (result) {
                    this.formData.phone = result;
                    this.findByPhone();
                }
            }
        },
        created() {
            this.resetErrors();
            if (this.phone) {
                this.formData.phone = this.phone;
                this.findByPhone();
            }

            this.subscriptionValues = _.map(this.subscriptions, (o, key) => { return {"label": o.title + ' ' + o.price, "value": key} });
            this.backUrl = location.href;
        }, watch: {
            "subscription": {
                "handler": function () {
                    this.formData.subscription_id = this.subscription ? this.subscription.value : 0;
                },
                "deep": true,
            },
            "formData.phone": function () {
                this.clientFounded = false;
            }
        }
    }
</script>
